//Modifing/Disabling some abilities
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.charability2 == CA2_SPINDASH
			if ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
				player.charability2 = CA2_NONE
			else
				player.charability2 = CA2_SPINDASH
			end
		end
	end
end)

//Flying
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.charability == CA_FLY and player.powers[pw_tailsfly] == 8*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.powers[pw_tailsfly] = 1*TICRATE
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.charability == CA_SWIM and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.charability = CA_FLY --Idk \('-')/
		end
	end
end)

//Climbing
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.mo.state == S_PLAY_CLING or player.mo.state == S_PLAY_CLIMB) and player.climbing > 0 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.mo.state = S_PLAY_SPRING
			P_SetObjectMomZ(player.mo, 12*FRACUNIT)
			P_InstaThrust(player.mo, player.mo.angle, 10*FRACUNIT)
			player.pflags = $|PF_JUMPED|PF_THOKKED
		end
	end
end)

//Modifying Power-Ups
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.powers[pw_sneakers] == 20*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) and not player.powers[pw_invulnerability] then
			player.powers[pw_sneakers] = 10*TICRATE
		end
	end
end)

//Attacks
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatatk == nil and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatatk = 8
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatatk >= 0 and not ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatatk = nil
		end
	end
end)

//Jump Damage
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.pflags & PF_JUMPED) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) and not ((player.pflags & PF_NOJUMPDAMAGE) or (player.charflags & SF_NOJUMPDAMAGE)) then
			local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
			P_KillMobj(hitbox)
			player.combatatk = 8
		end
	end
end)

//Gliding Damage
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.state == S_PLAY_GLIDE and (player.cmd.buttons & BT_JUMP) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES)) then
			local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
			P_KillMobj(hitbox)
			player.combatatk = 8
		end
	end
end)

//Twinspin Damage
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.charability == CA_TWINSPIN and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mo.state == S_PLAY_TWINSPIN
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				player.combatatk = 13
			end
		end
	end
end)

//Twinspin Damage
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.charability2 == CA2_MELEE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mo.state == S_PLAY_MELEE
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				player.combatatk = 13
			end
		end
	end
end)

//Bounce
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.charability == CA_BOUNCE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mo.state == S_PLAY_BOUNCE_LANDING
				player.mo.state = S_PLAY_FALL
				P_NukeEnemies(player.mo, player.mo, 90*FRACUNIT)
				P_SetObjectMomZ(player.mo, 14*FRACUNIT)
				player.pflags = $ + PF_THOKKED - PF_BOUNCING
				player.combatatk = 15
			end
		end
	end
end)

//DashMode Damage
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.state == S_PLAY_DASH and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
			P_KillMobj(hitbox)
			player.combatatk = 24
		end
	end
end)

//Power Stones Damage
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.powers[pw_sneakers] > 0 and player.powers[pw_invulnerability] > 0 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combatatk = 65
			if player.cmd.buttons & BT_FIRENORMAL
				player.powers[pw_sneakers] = 0
				player.powers[pw_invulnerability] = 0
				P_BlackOw(player)
				P_NukeEnemies(player.mo, player.mo, 1170*FRACUNIT)
				P_RadiusAttack(player.mo, player.mo, 1170*FRACUNIT, DMG_NUKE, false)
				S_StartSound(player.mo, sfx_bkpoof)
			end
		end
	end
end)

//Additional Huds
local function hudstuff(v, player, cam)
	if (player.mo and player.powers[pw_sneakers] > 0 and player.powers[pw_invulnerability] > 0 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)))
		v.drawString(62, 180, "Fire Normal = Chaos Blast!", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_GREENMAP|V_PERPLAYER)
	end
end

hud.add(hudstuff, player)