addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.combatpain == nil and player.combathpset == nil and player.damagereceiver == nil and player.damageresulttimer == nil then
			player.combatpain = false
			player.combathpset = false
			player.damagereceiver = 0
			player.damageresulttimer = 1*TICRATE+20
		end
	end
end)

//Setting HP for the characters
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
        if player.combathp == nil and player.maxcombathp == nil and player.playerstate == PST_LIVE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combathp = 250
			player.maxcombathp = 253
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.realtime == 1 and not ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF) or player.playerstate == PST_LIVE) then
			player.combathp = nil
			player.maxcombathp = nil
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
	end
end)

//Damaged by player
addHook("MobjDamage", function(mo, inf, source)
	if mo and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF))
	and mo.player
	and mo.player.playerstate == PST_LIVE
		if inf and source and source.valid and source.player 
			if not mo.player.powers[pw_shield]
				mo.player.combathp = $ - source.player.combatatk
				mo.player.powers[pw_flashing] = 10
				P_AddPlayerScore(source.player, source.player.combatatk) --that's how you gain points __('-')/
				P_DoPlayerPain(mo.player, source, inf)
				P_PlayerRingBurst(mo.player, 4)
				source.player.rings = $ + 4
				P_PlayerWeaponPanelBurst(mo.player)
				P_PlayerWeaponAmmoBurst(mo.player)
				P_PlayerEmeraldBurst(mo.player)
				P_PlayerFlagBurst(mo.player)
				S_StartSound(mo, sfx_altow1)
				P_PlayRinglossSound(mo,mo.player)
				print(source.player.name + "\x87 dealt \x85" + source.player.combatatk + "\x85 HP" + "\x80 to " + mo.player.name + "\x85" + "("+mo.player.combathp+"/"+mo.player.maxcombathp+")")
			end		
		end
		return true
	end
end, MT_PLAYER)

//by enemy/hazard
addHook("MobjDamage", function(mo, inf, source)
	if mo and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF))
	and mo.player
	and mo.player.playerstate == PST_LIVE
		if inf and source and source.valid and not source.player 
			if not mo.player.powers[pw_shield]
				mo.player.combathp = $ - 15
				mo.player.powers[pw_flashing] = 25
				P_DoPlayerPain(mo.player, source, inf)
				S_StartSound(mo, sfx_altow1)
				P_PlayRinglossSound(mo,mo.player)
				P_PlayerFlagBurst(mo.player)
			end
		end
		return true
	end
end, MT_PLAYER)

//Shield Damage
addHook("MobjDamage", function(mo, inf, source)
	if mo and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF))
	and mo.player
	and mo.player.playerstate == PST_LIVE
		if inf
		and source
		and source.valid
		and mo.player.powers[pw_shield]
			mo.player.powers[pw_flashing] = 4*TICRATE
			mo.player.powers[pw_shield] = SH_NONE
			P_DoPlayerPain(mo.player, source, inf)
			S_StartSound(mo, sfx_shldls)
			P_SpawnShieldOrb(mo.player)
			P_PlayerFlagBurst(mo.player)
		end
		return true
	end
end, MT_PLAYER)

//I-Frames
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.powers[pw_flashing] == 3*TICRATE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.powers[pw_flashing] = 14
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combathp > 0 and player.rings == 0 and player.playerstate == PST_LIVE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.rings = 1 --in case they die regardless their HP
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combathp <= 0 and player.playerstate == PST_LIVE and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			P_KillMobj(player.mo) --0 HP \(x_x)/
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combathp <= 0 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combathp = 0 --What does it mean when your HP is negative
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.playerstate == PST_DEAD then
			player.combathp = nil --you get your HP back when you respawn
			player.maxcombathp = nil
		end
	end
end)

//Heal
addHook("TouchSpecial", function(MT_RING, player)
	if ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF))
		if player.mo and player.mo.valid
			player.combathp = $ + 2 --collect rings to heal
		end
	end
end, MT_RING)

//Max HP
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combathp > player.maxcombathp -3 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combathp = player.maxcombathp -3
		end
	end
end)

//Get your HP when moving to next round
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.realtime == 2 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.combathp = player.maxcombathp - 3
		end
	end
end)

//Additional Huds
local function hudstuff(v, player, cam)
	if (player.mo and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)))
		v.drawString(12, 160, "HP:", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawString(32, 150, player.combathp + "/" + (player.maxcombathp-3), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawFill(50, 160, player.maxcombathp/3, 10, SKINCOLOR_BLACK)
		v.drawFill(51, 161, player.combathp/3, 8, SKINCOLOR_RED)
		v.drawFill(51, 166, player.combathp/3, 3, SKINCOLOR_CRIMSON)
	end
end

hud.add(hudstuff, player)