//Tackle
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_SPIN) and player.tackledelay == 0 and P_IsObjectOnGround(player.mo) and player.playerstate == PST_LIVE
				player.tackledelay = 1*TICRATE
				player.mo.state = S_PLAY_TACKLE1
				player.combatatk = 10
				S_StartSound(player.mo, sfx_spin)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mo.state == S_PLAY_TACKLE1 or player.mo.state == S_PLAY_TACKLE2 or player.mo.state == S_PLAY_TACKLE3 or player.mo.state == S_PLAY_TACKLE4 or player.mo.state == S_PLAY_TACKLE5
				P_SpawnGhostMobj(player.mo)
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				player.powers[pw_strong] = STR_ATTACK|STR_WALL|STR_ANIM
				player.combatatk = 10
			end
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.tackledelay == nil then
			player.tackledelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.tackledelay > 0 and player.tackledelay <= 10*TICRATE then
			player.tackledelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.tackledelay < 0 then
			player.tackledelay = 0
		end
	end
end)

//Shield
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM1) and player.weapondelay == 0*TICRATE and player.playerstate == PST_LIVE
				player.weapondelay = 20*TICRATE
				player.mo.colorized = true
				player.powers[pw_shield] = $|SH_FORCEHP|1
				S_StartSound(player.mo, sfx_forcsg)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.weapondelay > 10*TICRATE
				player.powers[pw_shield] = $|SH_FORCEHP
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.weapondelay == 10*TICRATE+25
				S_StartSound(player.mo, sfx_forcsg)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.weapondelay == 10*TICRATE
				player.mo.colorized = false
				player.powers[pw_shield] = $1 & ~SH_FORCEHP
				P_SpawnShieldOrb(player)
			end
		end
	end
end)

//Shockwave
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM2) and player.cshockwavedelay == 0*TICRATE and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE) or player.playerstate == PST_DEAD)
				player.cshockwavedelay = 12*TICRATE
				player.combatatk = 10
				player.mo.state = S_PLAY_SUPER_TRANS6
				S_StartSound(player.mo, sfx_s3k41)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mo.state == S_PLAY_SUPER_TRANS6 and player.cshockwavedelay == 12*TICRATE-10
				player.combatatk = 10
				player.powers[pw_invulnerability] = 10
				P_NukeEnemies(player.mo, player.mo, 235*FRACUNIT)
				local shockwave1 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave2 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave3 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave4 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave5 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave6 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave7 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave8 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave9 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave10 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave11 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				local shockwave12 = P_SpawnPlayerMissile(player.mo, MT_SHOCKWAVE)
				shockwave1.colorized = true
				shockwave2.colorized = true
				shockwave3.colorized = true
				shockwave4.colorized = true
				shockwave5.colorized = true
				shockwave6.colorized = true
				shockwave7.colorized = true
				shockwave8.colorized = true
				shockwave9.colorized = true
				shockwave10.colorized = true
				shockwave11.colorized = true
				shockwave12.colorized = true
				shockwave1.color = player.mo.color
				shockwave2.color = player.mo.color
				shockwave3.color = player.mo.color
				shockwave4.color = player.mo.color
				shockwave5.color = player.mo.color
				shockwave6.color = player.mo.color
				shockwave7.color = player.mo.color
				shockwave8.color = player.mo.color
				shockwave9.color = player.mo.color
				shockwave10.color = player.mo.color
				shockwave11.color = player.mo.color
				shockwave12.color = player.mo.color
				shockwave1.name = "\x88 's Shockwave"
				shockwave2.name = "\x88 's Shockwave"
				shockwave3.name = "\x88 's Shockwave"
				shockwave4.name = "\x88 's Shockwave"
				shockwave5.name = "\x88 's Shockwave"
				shockwave6.name = "\x88 's Shockwave"
				shockwave7.name = "\x88 's Shockwave"
				shockwave8.name = "\x88 's Shockwave"
				shockwave9.name = "\x88 's Shockwave"
				shockwave10.name = "\x88 's Shockwave"
				shockwave11.name = "\x88 's Shockwave"
				shockwave12.name = "\x88 's Shockwave"
				P_InstaThrust(shockwave1, player.mo.angle, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave2, player.mo.angle - ANGLE_45, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave3, player.mo.angle - ANGLE_90, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave4, player.mo.angle + ANGLE_45, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave5, player.mo.angle - ANGLE_180, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave6, player.mo.angle + ANGLE_90, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave7, player.mo.angle - ANGLE_135, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave8, player.mo.angle + ANGLE_135, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave9, player.mo.angle - ANG30, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave10, player.mo.angle + ANG30, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave11, player.mo.angle - ANG15, player.speed + 20*FRACUNIT)
				P_InstaThrust(shockwave12, player.mo.angle + ANG15, player.speed + 20*FRACUNIT)
				S_StartSound(player.mo, sfx_s3k45)
			end
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cshockwavedelay == nil then
			player.cshockwavedelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cshockwavedelay > 0 and player.cshockwavedelay <= 15*TICRATE then
			player.cshockwavedelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cshockwavedelay < 0 then
			player.cshockwavedelay = 0
		end
	end
end)

//Repel
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.repeldelay == nil then
			player.repeldelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.repeldelay > 0 and player.repeldelay <= 25*TICRATE then
			player.repeldelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.repeldelay < 0 then
			player.repeldelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM3) and player.repeldelay == 0*TICRATE and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE) or player.playerstate == PST_DEAD)
				player.repeldelay = 18*TICRATE
				player.combatatk = 15
				player.mo.state = S_PLAY_SUPER_TRANS2
				P_SetObjectMomZ(player.mo, 9*FRACUNIT)
				S_StartSound(player.mo, sfx_spin)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.repeldelay == 18*TICRATE-15 or player.repeldelay == 18*TICRATE-14 or player.repeldelay == 18*TICRATE-13
				player.mo.state = S_PLAY_SUPER_TRANS6
				player.charability = CA_TELEKINESIS --to be able to yeet nearby opponents
				player.combatatk = 15
				P_Telekinesis(player, 20*FRACUNIT, 270*FRACUNIT)
				local repel = P_NukeEnemies(player.mo, player.mo, 270*FRACUNIT)
				S_StartSound(player.mo, sfx_s3k46)
			end
		end
	end
end)

//Get your ability back
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.realability == nil and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.charability == CA_THOK
				player.realability = 1
			elseif player.charability == CA_FLY
				player.realability = 2
			elseif player.charability == CA_GLIDEANDCLIMB
				player.realability = 3
			elseif player.charability == CA_TWINSPIN
				player.realability = 4
			elseif player.charability == CA_BOUNCE
				player.realability = 5
			elseif player.charability == CA_FLOAT
				player.realability = 6
			elseif player.charability == CA_SLOWFALL
				player.realability = 7
			elseif player.charability == CA_HOMINGTHOK
				player.realability = 8
			elseif player.charability == CA_AIRDRILL
				player.realability = 9
			elseif player.charability == CA_DOUBLEJUMP
				player.realability = 10
			elseif player.charability == CA_SWIM
				player.realability = 11
			elseif player.charability == CA_FALLSWITCH
				player.realability = 12
			elseif player.charability == CA_JUMPBOOST
				player.realability = 13
			elseif player.charability == CA_JUMPTHOK
				player.realability = 14
			elseif player.charability == CA_TELEKINESIS
				player.realability = 15
			end
			R_SetPlayerSkin(player, player.mo.skin)
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.repeldelay == 17*TICRATE
				if player.realability == 1
					player.charability = CA_THOK
				elseif player.realability == 2
					player.charability = CA_FLY
				elseif player.realability == 3
					player.charability = CA_GLIDEANDCLIMB
				elseif player.realability == 4
					player.charability = CA_TWINSPIN
				elseif player.realability == 5
					player.charability = CA_BOUNCE
				elseif player.realability == 6
					player.charability = CA_FLOAT
				elseif player.realability == 7
					player.charability = CA_SLOWFALL
				elseif player.realability == 8
					player.charability = CA_HOMINGTHOK
				elseif player.realability == 9
					player.charability = CA_AIRDRILL
				elseif player.realability == 10
					player.charability = CA_DOUBLEJUMP
				elseif player.realability == 11
					player.charability = CA_SWIM
				elseif player.realability == 12
					player.charability = CA_FALLSWITCH
				elseif player.realability == 13
					player.charability = CA_JUMPBOOST
				elseif player.realability == 14
					player.charability = CA_JUMPTHOK
				elseif player.realability == 15
					player.charability = CA_NONE
				end
				R_SetPlayerSkin(player, player.mo.skin)
			end
		end
	end
end)

//Effective Guarding
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cguardtimer >= 5*TICRATE and player.combatrole == 5 then
			player.cguardtimer = 5*TICRATE
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.cmd.buttons & BT_FIRENORMAL) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if P_IsObjectOnGround(player.mo) and player.combatrole == 5 and not player.playerstate == PST_DEAD
				player.mo.state = S_PLAY_CGUARD
				player.cguardtimer = $+1
				player.combatatk = 11
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.cmd.buttons & BT_FIRENORMAL) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) and player.combatrole == 5 then
			if player.cguardtimer <= 3*TICRATE+25 and P_IsObjectOnGround(player.mo)
				if player.mo.state == S_PLAY_CGUARD
					local hitbox = P_SpawnPlayerMissile(player.mo, MT_CGUARDHITBOX)
					P_KillMobj(hitbox)
					player.powers[pw_strong] = STR_GUARD|STR_ANIM
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.normalspeed = 36*FRACUNIT
		end
	end
end)

//reset cooldown on respawn or on beginning of the round
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.realtime == 1 or player.playerstate == PST_REBORN) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.tackledelay = 0
			player.cshockwavedelay = 0
			player.repeldelay = 0
		end
	end
end)

local function hudstuff(v, player, cam)
	if (player.mo and player.combatrole == 5 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)))
		v.drawString(12, 110, "Tackle(S):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_SKYMAP|V_PERPLAYER)
		v.drawString(12, 120, "Shield(C1):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_SKYMAP|V_PERPLAYER)
		v.drawString(12, 130, "Shockwave(C2):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_SKYMAP|V_PERPLAYER)
		v.drawString(12, 140, "Repel(C3):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_SKYMAP|V_PERPLAYER)
		v.drawFill(116, 110, player.tackledelay/4, 8, SKINCOLOR_SKY)
		v.drawFill(120, 120, player.weapondelay/4, 8, SKINCOLOR_SKY)
		v.drawFill(135, 130, player.cshockwavedelay/4, 8, SKINCOLOR_BLUE)
		v.drawFill(125, 140, player.repeldelay/4, 8, SKINCOLOR_SKY)
	end
end

hud.add(hudstuff, player)