//Punch
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_SPIN) and P_IsObjectOnGround(player.mo) and player.weapondelay == 0 and player.playerstate == PST_LIVE and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE))
				player.mo.state = S_PLAY_PUNCH
				P_Thrust(player.mo, player.mo.angle, 15*FRACUNIT)
				P_SetObjectMomZ(player.mo, 2*FRACUNIT)
				S_StartSound(player.mo, sfx_mswing)
				player.weapondelay = 110
				player.combatatk = 24
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mo.state == S_PLAY_PUNCH
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.fuse = 4
				ghost.colorized = true
				ghost.color = player.mo.color
				player.weapondelay = 110
				player.powers[pw_strong] = STR_ATTACK|STR_WALL|STR_ANIM
				player.combatatk = 24
			end
		end
	end
end)

//Slam Down
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cslamdown == nil then
			player.cslamdown = false
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cslamdelay == nil then
			player.cslamdelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cslamdelay > 0 and player.cslamdelay <= 10*TICRATE then
			player.cslamdelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.cslamdelay < 0 then
			player.cslamdelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.pflags & PF_JUMPED) and (player.cmd.buttons & BT_SPIN) and player.cslamdown == false and player.cslamdelay == 0 and player.playerstate == PST_LIVE  and not (P_IsObjectOnGround(player.mo) or player.pflags & PF_THOKKED or (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE)) or player.playerstate == PST_DEAD)
				player.mo.state = S_PLAY_SUPER_TRANS6
				P_SetObjectMomZ(player.mo, -40*FRACUNIT)
				S_StartSound(player.mo, sfx_zoom)
				player.cslamdown = true
				player.cslamdelay = 6*TICRATE
				player.combatatk = 32
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.cslamdown == true and not player.mo.state == S_PLAY_SUPER_TRANS6
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				P_SetObjectMomZ(player.mo, -40*FRACUNIT)
				P_SpawnGhostMobj(player.mo)
				S_StartSound(player.mo, sfx_mswing)
				player.mo.state = S_PLAY_ROLL
				player.combatatk = 40
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.cslamdown == true and P_IsObjectOnGround(player.mo)
				local groundstomp = P_NukeEnemies(player.mo, player.mo, 160*FRACUNIT)
				P_RadiusAttack(player.mo, player.mo, 160*FRACUNIT, DMG_NUKE, false)
				P_StartQuake(5*FRACUNIT, 5)
				S_StartSound(player.mo, sfx_s3k59)
				player.cslamdown = false
				player.mo.state = S_PLAY_GLIDE_LANDING
				player.combatatk = 34
			end
		end
	end
end)

//Counter
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.counterdelay == nil then
			player.counterdelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.counterdelay > 0 and player.cslamdelay <= 15*TICRATE then
			player.counterdelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.counterdelay < 0 then
			player.counterdelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mcounter == nil then
			player.mcounter = false
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mcounter == false and (player.cmd.buttons & BT_CUSTOM1) and player.counterdelay == 0 and player.playerstate == PST_LIVE
				S_StartSound(player.mo, sfx_s3k59)
				player.counterdelay = 14*TICRATE
				player.weapondelay = 1*TICRATE
				player.cslamdelay = 1*TICRATE
				player.mcounter = true
				player.mo.colorized = true
				player.mo.state = S_PLAY_COUNTER
				player.combatatk = 25
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mcounter == true
				player.powers[pw_shield] = $|SH_PROTECTSPIKE
				P_Thrust(player.mo, player.mo.angle - ANGLE_180, FRACUNIT/5)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mcounter == true and player.counterdelay < 13*TICRATE
				player.mcounter = false
				player.powers[pw_shield] = $1 & ~SH_PROTECTSPIKE
				P_SpawnShieldOrb(player)
				player.mo.colorized = false
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.mcounter == true and P_PlayerInPain(player)
				player.powers[pw_shield] = $1 & ~SH_PROTECTSPIKE
				S_StartSound(player.mo, sfx_bsnipe)
				P_InstaThrust(player.mo, player.mo.angle, player.speed+ 5*FRACUNIT)
				P_StartQuake(8*FRACUNIT, 7)
				P_RadiusAttack(player.mo, player.mo, 110*FRACUNIT, DMG_NUKE)
				player.mcounter = false
				player.mo.colorized = false
				player.mo.state = S_PLAY_SPRING
				player.powers[pw_invulnerability] = 20
				player.combatatk = 25
			end
		end
	end
end)

//Quake
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.quakedelay == nil then
			player.quakedelay = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.quakedelay > 0 and player.cslamdelay <= 35*TICRATE then
			player.quakedelay = $-1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.quakedelay < 0 then
			player.quakedelay = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if (player.cmd.buttons & BT_CUSTOM2) and player.quakedelay == 0 and not (P_PlayerInPain(player) or (player.crolechoosing > 0 and player.crolechoosing <= 16*TICRATE) or player.playerstate == PST_DEAD)
				S_StartSound(player.mo, sfx_s3k59)
				player.quakedelay = 24*TICRATE
				player.weapondelay = 5*TICRATE
				player.cslamdelay = 5*TICRATE
				player.mo.state = S_PLAY_SUPER_TRANS6
				player.combatatk = 9
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			if player.quakedelay > 20*TICRATE and not (player.mo.state == S_PLAY_SUPER_TRANS6 or player.mo.state == S_PLAY_SUPER_TRANS1)
				player.powers[pw_invulnerability] = 10
				player.mo.state = S_PLAY_SUPER_TRANS1
				local hitbox = P_SpawnPlayerMissile(player.mo, MT_CHITBOX)
				P_KillMobj(hitbox)
				P_StartQuake(10*FRACUNIT, 2)
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.fuse = 3
				ghost.colorized = true
				local quake = P_NukeEnemies(player.mo, player.mo, 480*FRACUNIT)
				S_StartSound(player.mo, sfx_pstop)
				player.combatatk = 13
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.normalspeed = 34*FRACUNIT
		end
	end
end)

//reset cooldown on respawn or on beginning of the round
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if (player.realtime == 1 or player.playerstate == PST_REBORN) and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)) then
			player.quakedelay = 0
			player.cslamdelay = 0
			player.counterdelay = 0
		end
	end
end)

local function hudstuff(v, player, cam)
	if (player.mo and player.combatrole == 1 and ((gametype == GT_COMBAT) or (gametype == GT_TEAMCOMBAT) or (gametype == GT_COMBATLIVES) or (gametype == GT_TEAMCOMBATLIVES) or (gametype == GT_COMBATCTF)))
		v.drawString(12, 110, "Punch (Spin):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawFill(110, 110, player.weapondelay/4, 8, SKINCOLOR_RED)
		v.drawString(12, 120, "Ground Pound (S air):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ORANGEMAP|V_PERPLAYER)
		v.drawFill(167, 120, player.cslamdelay/4, 8, SKINCOLOR_ORANGE)
		v.drawString(12, 130, "Counter(C1):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_REDMAP|V_PERPLAYER)
		v.drawFill(127, 130, player.counterdelay/4, 8, SKINCOLOR_RED)
		v.drawString(12, 140, "Earth Quake (C2):", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_ORANGEMAP|V_PERPLAYER)
		v.drawFill(164, 140, player.quakedelay/4, 8, SKINCOLOR_ORANGE)
	end
end

hud.add(hudstuff, player)